/**************************************************************************
**       Title: ConnectedComponentLabeling
**    $RCSfile: ConnectedComponentLabeling.hh,v $
**   $Revision: 1.4 $$Name:  $
**       $Date: 2005/05/02 11:25:37 $
**   Copyright: GPL $Author: fehr $
** Description:
**
**                      
**                  
**-------------------------------------------------------------------------
**              
**  $Log: ConnectedComponentLabeling.hh,v $
**              
**                  
**************************************************************************/

#ifndef CONNECTED_COMPONENT_LABELING
#define CONNECTED_COMPONENT_LABELING

#include "IntImage.hh"
#include <queue>

/*======================================================================*/
/*!             
 *  \class ConnectedComponentLabeling
 *  \brief labels objects in binary input IntImage
 *          
 */
/*======================================================================*/

class ConnectedComponentLabeling
{
    public:
  /*======================================================================*/
  /*! 
   *   Default Constructor. 
   */
  /*======================================================================*/
	ConnectedComponentLabeling()
	    :NumberOfObjects(0)
	{
	    //nothing else to do
	};

    /*======================================================================*/
    /*!
     *   label all objects
     * \param image 	binary IntImage to be overwritten with labels 
     *
     *======================================================================*/	 
 	void label(IntImage& image);
    
     /*-----------------------------------------------------------------------
      *  return number of labeled objects
      *  \return number of labeled objects
      *  ---------------------------------------------------------------------*/
	int getNumberOfObjects();
    private:
	std::queue<int> _todo; //queue of pixels still to process
	int NumberOfObjects;
};




#endif 
