/**************************************************************************
**       Title: RGBClassifier
**    $RCSfile: RGBClassifier.cc,v $
**   $Revision: 1.4 $$Name:  $
**       $Date: 2005/05/02 11:25:37 $
**   Copyright: GPL $Author: fehr $
** Description:
**
**    
**
**-------------------------------------------------------------------------
**
**  $Log: RGBClassifier.cc,v $
**
**
**************************************************************************/


#include "RGBClassifier.hh"


RGBClassifier::RGBClassifier(const RGBColor& color, int r, int g, int b)
{
    setTolerance(r,g, b);
    setObjektColor(color);
} 

void RGBClassifier::setTolerance(int r, int g, int b)
{
    tolerance_r = r;
    tolerance_g = g;
    tolerance_b = b;
}

void RGBClassifier::setObjektColor(const RGBColor& color)
{
    ObjectColor = color;
}

IntImage* RGBClassifier::classify(const SimpleRGBImage& in)
{
    IntImage* binary = new IntImage(in.width(), in.height());
    for (int i = 0;i<in.size();i++)
    {
	if( 
		(
		    (
			abs(in[i].red()-ObjectColor.red())
		    ) 
		    <= tolerance_r
		)
	    &&
		(
		    (
			abs(in[i].green()-ObjectColor.green())
		    ) 
		    <= tolerance_g
		)
	    &&
		(
		    (
			abs(in[i].blue()-ObjectColor.blue())
		    ) 
		    <= tolerance_b
		)
	    )
			
	{
	    binary->operator[](i)=1;
	}
	else
	{
	    binary->operator[](i)=0;
	}
    }		
 
    return binary;
}
